<?php
require_once "modelo/utilidades.php";
require_once "modelo/datos.php";
class cursos extends datos
{

    //variables para retornar valores por
    //ajax a la vista
    private $js = array();
    public function pjs()
    {
        $this->js['accion']         = '';
        $this->js['bien']           = '';
        $this->js['html']           = '';
        $this->js['etiqueta']       = '';
        $this->js['totalregistros'] = '';
    }
    public function sjs()
    {
        return $this->js;
    }

    public function __construct()
    {

    }

    //metodo para leer los datos del
    //formulario enviado por ajax
    private $formulario;
    public function p_formulario($v)
    {
        $this->formulario = $v;
        foreach ($this->formulario as $nombre_campo => $valor) {
            $asignacion = "\$this->" . $nombre_campo . "='" . trim(mb_strtoupper($valor)) . "';";
            eval($asignacion);
        }
    }

//metodo para validar los datos de entrada
    public function validacursos()
    {
        $bien = true;
        //grupo de expresiones regulares para
        //validacion
        $nombrecurso = '/^([a-zA-Z0-9ÑñáéíóúÁÉÍÓÚ \b]{6,150})$/';
        $notascurso  = '/^([a-zA-ZÑ0-9ñáéíóúÁÉÍÓÚ \b]{6,550})$/';

        if (!preg_match($nombrecurso, $this->nombrecurso)
            || trim($this->nombrecurso) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: El nombre del curso es requerido";
            $this->js['etiqueta'] = "nombrecurso";
            $bien                 = false;
        }
        if (!preg_match($notascurso, $this->notascurso)
            || trim($this->notascurso) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: Escriba en notas del curso";
            $this->js['etiqueta'] = "notascurso";
            $bien                 = false;
        }
        return $bien;
    }
    public function validafacilitadores()
    {
        $bien = true;
        //grupo de expresiones regulares para
        //validacion
        $rif      = '/^([JjVvGg])([-]{1})([0-9]{8,10})$/';
        $rd       = '/^([a-zA-Z0-9ÑñáéíóúÁÉÍÓÚ \b]{6,150})$/';
        $telefono = '/^([0-9]{10,12})$/';
        if (!preg_match($rif, $this->riffacilitador)
            || trim($this->riffacilitador) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: El Rif debe comenzar por [JjVvGg] seguido de [-] mas
		entre 8 y 10 digitos";
            $this->js['etiqueta'] = "riffacilitador";
            $bien                 = false;
        } elseif (!preg_match($rd, $this->razonsocial)
            || trim($this->razonsocial) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: La razon social debe contener entre 6 y 150 caracteres";
            $this->js['etiqueta'] = "razonsocial";
            $bien                 = false;
        } elseif (!preg_match($rd, $this->domiciliofiscal)
            || trim($this->domiciliofiscal) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: El domicilio fiscal debe contener entre 6 y 150 caracteres";
            $this->js['etiqueta'] = "domiciliofiscal";
            $bien                 = false;
        } elseif (!preg_match($telefono, $this->telefono)
            || trim($this->telefono) == '') {
            $this->js['bien'] = "no";
            $this->js['html'] = "
        ERROR: El telefono debe contener entre 10 y 12 digitos";
            $this->js['etiqueta'] = "telefono";
            $bien                 = false;
        }
        return $bien;
    }
    public function validarfecha($fecha)
    {
        $valido = true;
        $a      = DateTime::createFromFormat("Y-m-d", $fecha);
        if ($a) {
            $calculo = $a->diff(new DateTime());
            $x       = $calculo->y;
            if ($x < 18) {
                $valido = false;
            }
        } else {
            $valido = false;
        }
        return $valido;
    }

    public function registrarcurso()
    {
        $this->js['accion'] = "Registrar curso";
        if ($this->validacursos()) {
            $busca = $this->Busca("Select id from
							   cursos where
							   trim(upper(nombrecurso)) =
							   trim(upper('$this->nombrecurso'))");
            if ($busca) {
                $this->js['bien'] = "no";
                $this->js['html'] = "
			ERROR: Ya existe un curso con ese nombre";
                $this->js['etiqueta'] = "nombrecurso";
            } else {
                $guarda = $this->Ejecuta("Insert into
			cursos (nombrecurso,
			notascurso)
			values
			('$this->nombrecurso',
			'$this->notascurso')");

                $this->js['bien'] = "si";
                $this->js['html'] = "
			EXITO: El curso ha sido registrado";
                $this->js['etiqueta'] = "nombrecurso";
            }
        }
    }

    public function registrarfacilitador()
    {
        $this->js['accion'] = "Registrar facilitador";
        if ($this->validafacilitadores()) {
            $busca = $this->Busca("Select id from
							   facilitadores where
							   trim(upper(riffacilitador)) =
							   trim(upper('$this->riffacilitador'))");
            if ($busca) {
                $this->js['bien'] = "no";
                $this->js['html'] = "
			ERROR: Ya existe un facilitador";
                $this->js['etiqueta'] = "riffacilitador";
            } else {
                $guarda = $this->Ejecuta("Insert into
			facilitadores (riffacilitador,
			razonsocial,domiciliofiscal,
			telefono,correo)
			values
			('$this->riffacilitador',
			'$this->razonsocial',
			'$this->domiciliofiscal',
			'$this->telefono',
			'$this->correo')");
                $this->js['bien'] = "si";
                $this->js['html'] = "
			EXITO: El facilitador ha sido registrado";
                $this->js['etiqueta'] = "riffacilitador";
            }
        }
    }

    public function modificarfacilitador()
    {

        $this->js['accion'] = "Modificar facilitador";
        if ($this->validafacilitadores()) {
            $busca = $this->Busca("Select id from
							   facilitadores where
							   trim(upper(riffacilitador)) =
							   trim(upper('$this->riffacilitador'))");
            if (!$busca) {
                $this->js['bien'] = "no";
                $this->js['html'] = "
			ERROR: No existe un facilitador con ese rif";
                $this->js['etiqueta'] = "riffacilitador";
            } else {
                $modifica = $this->Ejecuta("update facilitadores
			set razonsocial=
			'$this->razonsocial',
			domiciliofiscal=
			'$this->domiciliofiscal',
			telefono=
			'$this->telefono',
			correo=
			'$this->correo'
			where
			trim(upper(riffacilitador)) =
			trim(upper('$this->riffacilitador'))
			");

                $this->js['bien'] = "si";
                $this->js['html'] = "
			EXITO: Registro modificado";
                $this->js['etiqueta'] = "riffacilitador";
            }
        }
    }

    public function modificarcurso()
    {

        $this->js['accion'] = "Modificar curso";
        if ($this->validacursos()) {
            $busca = $this->Busca("Select id from
							   cursos where
							   trim(upper(nombrecurso)) =
							   trim(upper('$this->nombrecurso'))");
            if (!$busca) {
                $this->js['bien'] = "no";
                $this->js['html'] = "
			ERROR: No existe un curso con ese nombre";
                $this->js['etiqueta'] = "nombrecurso";
            } else {
                $modifica = $this->Ejecuta("update cursos
			set notascurso=
			'$this->notascurso'
			where
			trim(upper(nombrecurso)) =
			trim(upper('$this->nombrecurso'))
			");

                $this->js['bien'] = "si";
                $this->js['html'] = "
			EXITO: Registro modificado";
                $this->js['etiqueta'] = "nombrecurso";
            }
        }
    }

    public function muestrafacilitadores()
    {
        $b = $this->Busca("Select id, riffacilitador,
			 razonsocial from
			 facilitadores
			 order by razonsocial");
        if ($b) {
            $this->js['html'] = json_encode($b);
        } else {
            $this->js['html'] = "";
        }
    }
    public function cargacursos()
    {
        $b = $this->Busca("Select nombrecurso,
			 notascurso from
			 cursos
			 order by nombrecurso");
        if ($b) {
            $this->js['html'] = json_encode($b);
        } else {
            $this->js['html'] = "";
        }
    }

}
